<!DOCTYPE html>
<html lang="es">
<head>
    <meta charset="UTF-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <title>Capitulo_17</title>
</head>
<body>
    <h1>Capitulo 17</h1>
    <a>Ejercicio 19</a>

    <script>

        const buscarNumFaltante = (arr, n) => {

            let XOR = arr[0];

            for (let i = 1; i < n-2; i++)
                XOR ^= arr[i];

            for (let i = 1; i <= n; i++)
                XOR ^= i;
  
            let set_bit_no = XOR & ~(XOR-1);
            let x = 0, y = 0;
    
            for (let i = 0; i < n-2; i++) {
        
                if (arr[i] & set_bit_no)
                    x = x ^ arr[i]; 
                else
                    y = y ^ arr[i]; 
            }
    
            for (let i = 1; i <= n; i++) {

                if (i & set_bit_no)
                    x = x ^ i; 
                else
                    y = y ^ i;
            }
  
            console.log(`Los dos números faltantes son ${x} ${y}`);
        }

        let arr = [1, 2, 3, 5, 6, 7, 8, 10];
        n = 2 + arr.length;
  
        buscarNumFaltante(arr, n);


    </script>
    
</body>
</html>